// From 
// Monte-Carlo Methods in Global Illumination
// by Szirmay-Kalos Laszlo
// p. 48

typedef unsigned int uint;
double RI_vdC(uint bits, uint r = 0);
double RI_S(uint i, uint r = 0);
double RI_LP(uint i, uint r = 0);

class Halton {
private:
  double value, inv_base;

public:
  void Number(long i, int base);
  void Next();
  operator double(){ return value; }  // called by name of instance, e.g. Halton h; x=h;
};

class MultiHalton {
private:
  const static int dim = 40;
  const static int primes[50];
  const static int predim = 10000;
  Halton h[dim];
  Halton preh[dim];
  double table[dim][predim];

public:
  MultiHalton();   // constructor
  double next(int d);
  double prenext(int d);
};
