
#include "HyperTexture.h"

void HyperTexture::init(){

  // compute array of random directions G
  for (int i=0; i<n; i++){
    SbVec3f x;
    do {
      x[0] = drand48()*2.0f-1.0f;
      x[1] = drand48()*2.0f-1.0f;
      x[2] = drand48()*2.0f-1.0f;
    } while (x.length()>1.0f);
    x.normalize();
    G[i] = x;
  }

  // compute permuted set of integers, P

  // initialize ordered list of integers
  for (int i=0; i<n; i++)
    P[i] = i;

  // shuffle order
  for (int i=0; i<n; i++){
      
    int j = (int)(drand48()*n);

    // swap i and j
    int t = P[i];
    P[i] = P[j];
    P[j] = t;
  }
}

float HyperTexture::noise(SbVec3f x) const {
  int xi[3];
  xi[0] = (int)floor(x[0]);
  xi[1] = (int)floor(x[1]);
  xi[2] = (int)floor(x[2]);

  float y=0.0f;
  for (int i=xi[0]; i<=xi[0]+1; i++)
    for (int j=xi[1]; j<=xi[1]+1; j++)
      for (int k=xi[2]; k<=xi[2]+1; k++)
	y += Omega(i, j, k, SbVec3f(x[0]-i, x[1]-j, x[2]-k));

  return y;
}

