
#include "HyperTextureDataSet.h"

// read file into temporary memory block,
// pass to other useData() for further processing.
void HyperTextureDataSet::useData(char *filename, int _dim, int header, int fourBytes,
				  SbVec3f _min, SbVec3f _max){

  // store min and max
  min = _min;
  max = _max;

  // store dims
  dim[0] = _dim;
  dim[1] = _dim;
  dim[2] = _dim;

  // compute deltas (voxel size)
  // x1-x0
  voxel[0] = (max[0]-min[0])/(dim[0]-1);
  voxel[1] = (max[1]-min[1])/(dim[1]-1);
  voxel[2] = (max[2]-min[2])/(dim[2]-1);
  
  // 1/(x1-x0)
  invVoxel[0] = (dim[0]-1)/(max[0]-min[0]);
  invVoxel[1] = (dim[1]-1)/(max[1]-min[1]);
  invVoxel[2] = (dim[2]-1)/(max[2]-min[2]);

}
