//WWWWWW'''''''WW''''''''''''''''WWW'''''''WW''''WW''''''''WW''''''''''WWW''
//  WW                            WW       WW              WW           WW  
//  WW    W WW WW  WWW WWW   WWW  WW   WW  WW    WW  WWWW WWWW     WWW  WW  
//  WW    WW   WW W WW WW W W WW  WW  WWWW WW    WW WWW    WW     WW W  WW  
//  WW    WW   WW W WW WW W W WW  WW  WW   WW    WW   WWW  WW     WW    WW  
//  WW    WW   WW  WWW WW W  WWW WWWW  WWW WWWWW WW WWWW   WW      WWW WWWW 
//                            WW                                            
//''''''''''''''''''''''''''WWW'''''''''''''''''''''''''''''''''''''''''''''

#ifndef TRIANGLELISTCLASS
#define TRIANGLELISTCLASS

#include "Main.h"
#include "Triangle.h"
#include "GlobalVars.h"
class Ray; // forward declaration of Ray class

//#define EPSILON_MRT 0.003  // 0.00003 gives acne (Minimum Ray t)
#define EPSILON_MRT 0.0  // 0.00003 gives acne (Minimum Ray t)

class TriangleList {
private:
  static vector<Triangle *> allTris; // FIXME: This should be tri's not *'s
  static vector<EmissiveTriangle *> allEmisTris; // FIXME: This should be tri's not *'s
  static vector<bool> triBits, emisTriBits;
  vector<int> trilist;
  
public:

  ~TriangleList(){ }

  // Methods to add triangles
  void add(int i){
    trilist.push_back(i);
  }
  int add(Triangle *t){
    int id;
    if (!t->isEmissive()){
      allTris.push_back(t);
      id = allTris.size()-1;
    }
    else {
      allEmisTris.push_back(dynamic_cast<EmissiveTriangle *>(t));
      id = -(allEmisTris.size()-1);
    }
    trilist.push_back(id);
    return id;
  }
//   int addEmis(EmissiveTriangle *t){
//     allEmisTris.push_back(t);
//     int id = allEmisTris.size()-1;
//     id = -id; // signifies emissive
//     trilist.push_back(id);
//     return id;
//   }
  void add(TriangleList &l){
    trilist.insert(trilist.end(), l.trilist.begin(), l.trilist.end());
  }
  static void deleteAll();
  static void drawAll();
  void clear(){ trilist.clear(); }
  int intersect_ray(Ray &r, double t0=0.00001, double t1=1e8, int checkDist=1);    
  int size() const { return(trilist.size()); }
  void resizeToFit(){ std::vector<int>(trilist).swap(trilist); }
  
  //vector<int>::iterator begin(){    return(trilist.begin()); } // iterators
  //vector<int>::iterator end()  {    return(trilist.end());   }

  // methods to access primitive lists
  enum { TRI_TYPE, EMISTRI_TYPE, UNKNOWN_TYPE1, UNKNOWN_TYPE2 };
  static int idPrim(const int id){ return id & (3<<30) >> 30; }
  static int idIdx(const int id){ return id & 0x3FFFFFFF; }
  static Triangle* const primLists[4];
  static const int primSize[4];

  int id(int i){ return trilist[i]; }
  Triangle* tri(int i){
//     const int prim = idPrim(i);
//     const int idx = idIdx(i);
//     const int elemSize = primSize[prim];
//     return (Triangle *)(&((char *)primLists[prim])[elemSize*idx]);
    
    if (trilist[i]>=0) return allTris[trilist[i]];
    else return allEmisTris[-trilist[i]];
  }
  static Triangle* globalTri(int i){
    if (i>=0) return allTris[i];
    else return allEmisTris[-i];
  }
  int &operator[](int i){ return trilist[i]; }

  static void allocBits(){
    triBits.resize(allTris.size()*2, true);
    emisTriBits.resize(allEmisTris.size()*2, true);
  }
  enum BIT_LEFT_OR_RIGHT { BIT_LEFT, BIT_RIGHT };
  static void setAllBits(bool b){
    triBits.assign(b, triBits.size());
    emisTriBits.assign(b, emisTriBits.size());
  }
  static void freeBits(){
    triBits.clear();
    emisTriBits.clear();
  }
  static void setBit(int id, int leftOrRight, bool b){
    id *= 2;
    if (id>=0){
      id += leftOrRight;
      triBits[id]=b;
    }
    else {
      id = -id;
      id += leftOrRight;
      emisTriBits[id]=b;
    }
  }

  static void printBits(){
    cerr << "triBits: ";
    for (int i=0; i<allTris.size()*2; i++)
      cerr << (triBits[i] ? "t" : "F");
    cerr << "\nemisTriBits: ";
    for (int i=0; i<allEmisTris.size()*2; i++)
      cerr << (emisTriBits[i] ? "t" : "F");
    cerr << "\n";
  }
  static void printBits2();

  static bool getBit(int id, int leftOrRight){
    id *= 2;
    if (id>=0){
      id += leftOrRight;
      return triBits[id];
    }
    else {
      id = -id;
      id += leftOrRight;
      return emisTriBits[id];
    }
  }
  
};

#endif /* TRIANGLELISTCLASS */
